// 2012/10/27
#include <cstdio>
#include <iostream>
#include <fstream>
#include <cstring>
using namespace std;
const int Mod = 19491001;

struct node {
	long long m[2][2];
	node () { memset(m, 0, sizeof(m)); }
};
node raw;

int GetFib(int index);
node GetFibEx(int e);
long long gcd(long long x, long long y) {
	return 0==x%y ? y : gcd(y, x%y);
}

inline node MX(const node &x, const node &y) {
	node c;
	for (int i=0; i<2; ++i) {
		for (int j=0; j<2; ++j) {
			for (int k=0; k<2; ++k) {
				c.m[i][j] += x.m[i][k]*y.m[k][j];
				c.m[i][j] %= Mod;
			}
		}
	}
	return c;
}

int main() {
	raw.m[0][0] = 0; raw.m[0][1] = 1;
	raw.m[1][0] = 1; raw.m[1][1] = 1;
	freopen("Fibonacci.in", "r", stdin);
	freopen("Fibonacci.out", "w", stdout);	
	int times(0);
	cin >> times;
	while (times--) {
		int a(0), b(0);
		cin >> a >> b;
		int get = gcd(a, b);
		cout << GetFibEx(get).m[0][1] << endl;
//		cout << GetFib(get) << endl;
	}
	
	return 0;
}

node GetFibEx(int e) {
	if (0== e || 1 == e) {
		return raw;
	} else {
		node t;
		t = GetFibEx(e/2);
		if (1 & e) {
			return MX(t, MX(t, raw));
		} else {
			return MX(t, t);
		}
	}
}

int GetFib(int index) {
	if (0 == index || 1 == index) return 1;
	index--;
	int last = 0, now = 1;
	int temp(0);
	while (index--) {		
		temp = now;
		now = (now+last)%Mod;
		last = temp;
	}
	return now;
}

