// 2012/10/27
#include <cstdio>
#include <iostream>
#include <fstream>
#include <vector>
#include <utility>
#include <cstring>
using namespace std;

const int Maxn = 10000;
const int Len = 10;
char str[Maxn][11];
int v[10];
int n(0);
bool vis[Maxn];
int dis[Maxn];
vector<pair<int,int> > map[Maxn];

int Connect(int i, int j);
void Dijkstra(int v);

int main() {
	freopen("Math.in", "r", stdin);
	freopen("Math.out", "w", stdout);
	scanf("%d", &n);
	for (int i=0; i<n; ++i) {
		scanf("%s", str[i]);
	}
	for (int i=0; i<10; ++i) {
		scanf("%d", &v[i]);
	}
	for (int i=0; i<n; ++i) {
		for (int j=i+1; j<n; ++j) {
			int lcp = Connect(i, j);
			if (-1 != lcp) {
				map[i].push_back(make_pair(j, v[lcp]));
				map[j].push_back(make_pair(i, v[lcp]));
			}
		}
	}
	Dijkstra(0);
	printf("%d", dis[n-1]);
	return 0;
}

void Dijkstra(int v) {
	memset(vis, 0, sizeof(vis));
	memset(dis, 0x33, sizeof(dis));
	dis[v] = 0;
	while (true) {
		int mind(10000000), m(-1);
		for (int i=0; i<n; ++i) if (!vis[i] && dis[i]<mind) {
			mind = dis[m=i];
		}
		if (-1 == m) break;
		vis[m] = true;
		for (int i=0; i<(int)map[m].size(); ++i) {
			int u = map[m][i].first;
			int w = map[m][i].second;
			if (!vis[u] && dis[m]+w < dis[u]) {
				dis[u] = dis[m] + w;
			}
		}
	}
}

int Connect(int x, int y) {
	int l(-1), r(-1);
	for (int i=0; i<Len; ++i) if (str[x][i]!=str[y][i]) {
		if (-1 == l) { 
			l = i;
		} else if (-1 == r) {
			r = i;
		} else {
			return -1;
		}
	}
	if (-1 == r) {
		return max(l, Len-l);
	} else {
		if (str[x][l]==str[y][r] &&
			str[x][r]==str[y][l]) {
			return max(r-l-1, max(l, Len-r));
		} else {
			return -1;
		}
	}
}
