#include <fstream>
#include <cstring>
#include <algorithm>
#include <string>
#include <map>
#define MAXL 10005
#define INF 100000000
using namespace std;

ifstream fin("Math.in");
ofstream fout("Math.out");

int n;
int cost[10], dist[MAXL], queue[MAXL*5];
int last[MAXL], pre[MAXL*MAXL], to[MAXL*MAXL], val[MAXL*MAXL], tot = 0;
string tele[MAXL], tmp;
map<string, int> mymap;
bool vis[MAXL] = {false};

void build(int u, int v);

int main()
{
	ios::sync_with_stdio(false);
	fin >> n;
	for (int i = 0; i < 10; i++)
		fin >> cost[i];
	for (int i = 1; i <= n; i++)
	{
		fin >> tele[i];
		mymap[tele[i]] = i;
	}
	for (int i = 1; i <= n; i++)
		for (int j = 0; j < 10; j++)
		{
			for (int k = j + 1; k < 10; k++)
			{
				tmp = tele[i];
				swap(tmp[j], tmp[k]);
				fout << tmp << endl;
				if (mymap.find(tmp) != mymap.end())
					build(i, mymap[tmp]);
			}
			for (char c = '0'; c <= '9'; c++)
				if (tele[i][j] != c)
				{
					tmp = tele[i];
					tmp[j] = c;
					if (mymap.find(tmp) != mymap.end())
						build(i, mymap[tmp]);
				}
		}
	
	for (int i = 1; i <= n; i++)
		dist[i] = INF;
	dist[1] = 0;
	int head = 0, tail = 1;
	queue[0] = 1;
	vis[1] = true;
	while (head < tail)
	{
		int x = queue[head++];
		vis[x] = false;
		for (int i = last[x]; i; i = pre[i])
			if (dist[to[i]] > dist[x] + val[i])
			{
				dist[to[i]] = dist[x] + val[i];
				if (!vis[to[i]])
				{
					queue[tail++] = to[i];
					vis[to[i]] = true;
				}
			}
	}
	if (dist[n] < INF) fout << dist[n] << endl;
	else fout << -1 << endl;
	
	return 0;
}

void build(int u, int v)
{
	pre[++tot] = last[u];
	last[u] = pre[tot];
	to[tot] = v;
	int i;
	for (i = 0; i < 10; i++)
		if (tele[u][i] != tele[v][i])
			break;
	val[tot] = cost[i];
}