#include <cstdio>
#include <cstdlib>
using namespace std;

const int maxn = 10110, maxm = 2000010, mod = 10000007;
int n, htop;
int la[maxn], en[maxm], pre[maxm], tot, next[maxn], hash[mod+2];
long long tel[maxn], value[20], len[maxm], dis[maxn];
long long ten[20] = {1,10,100,1000,10000,100000,1000000,
                    10000000,100000000,1000000000ll,10000000000ll};
//计算内存
struct str{
    int x; long long w;
}heap[maxm];

inline void build(int,int,int);
void add(int,long long);
void del();
void read();
void work();
void dijk();

int main(){
    freopen("Math.in", "r", stdin);
    freopen("Math.out", "w", stdout);
    read();
    work();
    dijk();
    fclose(stdin);
    fclose(stdout);
    return 0;
}

inline void build(int u, int v, int w){
    len[++tot] = w;
    en[tot] = v;
    pre[tot] = la[u];
    la[u] = tot;
}
void add(int x, long long w){
    int i;
    i = ++htop;
    while (i>=2 && heap[i>>1].w>w){
        heap[i] = heap[i>>1];
        i>>=1;
    }
    heap[i].x = x;
    heap[i].w = w;
    return;
}
void del(){
    int i=1, j=2;
    htop--;
    while (j<=htop){
        if (j<htop && heap[j+1].w<heap[j].w) j++;
        if (heap[j].w>heap[htop+1].w) break;
        heap[i] = heap[j];
        i = j;
        j = i<<1;
    }
    heap[i] = heap[htop+1];
    return;
}
void work(){
    int i, j, k, l;
    long long a, b, y, x;
    for (i=1; i<=n; i++){
        for (l=1; l<=10; l++){
            x = (tel[i]/ten[l-1])%10;//第i个电话第l位数字(从右往左)
            //printf("%d %d %I64d\n", i, 10-l+1, x);
            for (k=0; k<=9; k++){
                if (k==x) continue;
                y = tel[i] + (k-x)*ten[l-1];
                if (!hash[y%mod]) continue;
                a = hash[y%mod];
                while (a>0 && y!=tel[a])
                    a = next[a];
                if (y==tel[a]) build(i, a, 10-l);//, printf("%d %I64d %d\n", i, a, 10-l);
            }
        }
        for (j=1; j<=9; j++)
            for (k=j+1; k<=10; k++){
                a = (tel[i]/ten[j-1])%10;
                b = (tel[i]/ten[k-1])%10;
                y = tel[i] +(b-a)*ten[j-1]+(a-b)*ten[k-1];
                if (!hash[y%mod] || a==b) continue;
                x = hash[y%mod];
                while (x>0 && y!=tel[x])
                    x = next[x];
                if (y==tel[x]) build(i, x, 10-k);//, printf("%d %I64d %d\n", i, x, 10-k);
            }
    }
}

void dijk(){
    int i, u, v;
    long long y;
    add(1, 0);
    dis[1] = 0;
    while (htop>0){
        while (htop>0 && hash[heap[1].x]==n+3) del();
        
        if (htop<=0) break;
        
        u = heap[1].x;
        y = heap[1].w;
        hash[u] = n+3;
        del();
        
        if (u==n){
            printf("%I64d\n", y);
            break;
        }
        
        for (i=la[u]; i; i=pre[i]){
            v = en[i];
            if (hash[v]!=n+3 && y + value[len[i]]<dis[v]){
                dis[v] = y + value[len[i]];
                add(v, y+value[len[i]]);
            }
        }
    }
    if (hash[n]!=n+3) printf("-1\n");
    return;
}
    
void read(){
    int i;
    long long x;
    scanf("%d", &n);
    for (i=1; i<=10; i++)
        scanf("%I64d", &value[i-1]);
    for (i=1; i<=n; i++){
        scanf("%I64d", &tel[i]);
        dis[i] = 0x7fffffff;
        x = tel[i]%mod;
        //printf("%d\n", x);
        if (hash[x]){
            x = hash[x];
            while (next[x]!=0) x = next[x];
            next[x] = i;
        }
        else hash[x] = i;
    }
    return;
}


