#include <fstream>
#include <algorithm>
const int MOD = 19491001;
using namespace std;
ifstream fin ("Fibonacci.in");
ofstream fout("Fibonacci.out");
struct matrix 
{ 
    long long d[2][2]; 
    matrix() {fill(&d[0][0], &d[1][1]+1, 0);} 
    matrix(int a) {d[0][0] = d[1][1] = 1;}
};
inline matrix operator * (matrix &a, matrix &b)
{
    matrix ans;
    for (int r=0; r<2; ++r)
        for (int c=0; c<2; ++c)
            for (int i=0; i<2; ++i)
                ans.d[r][c] += a.d[r][i]*b.d[i][c]%MOD;
    return(ans);
}
matrix super_power(matrix mat, long long n)
{
    if (n == 1) return(mat);
    if (n == 0) return(matrix(1));
    matrix mat2 = super_power(mat, n/2); 
    mat2 = mat2 * mat2;
    if (n & 1)
        return(mat2 * mat);
    else
        return(mat2);
}
inline long long fibonacci(long long n)
{
    matrix m;
    m.d[0][0] = m.d[0][1] = m.d[1][0] = 1;
    if (n > 2)
    {
        m = super_power(m, n-2);
        return((m.d[0][0] + m.d[1][0])%MOD);
    }
    else
    {
        return(1);
    }
}
int main(void)
{
    ios::sync_with_stdio(false);
    int gay;
    fin >> gay;
    for (int i=0; i<gay; ++i)
    {
        long long gcd, gay_a, gay_b;
        fin >> gay_a >> gay_b;
        gcd = __gcd(gay_a, gay_b);
        fout << fibonacci(gcd) << '\n'; 
    }
    fin.close();
    fout.close();
    return(0); 
}
